/**
 * <copyright>
 * </copyright>
 *
 * $Id: PurchaseOrder.java,v 1.1 2006/03/28 22:06:01 nickb Exp $
 */
package org.eclipse.emf.tutorial.advanced.po;

import java.util.Date;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.tutorial.advanced.customer.Customer;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Purchase Order</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getItems <em>Items</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getComment <em>Comment</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getOrderDate <em>Order Date</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getBillTo <em>Bill To</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getShipTo <em>Ship To</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getPreviousOrder <em>Previous Order</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getCustomer <em>Customer</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder()
 * @model
 * @generated
 */
public interface PurchaseOrder extends EObject
{
  /**
   * Returns the value of the '<em><b>Items</b></em>' containment reference list.
   * The list contents are of type {@link org.eclipse.emf.tutorial.advanced.po.Item}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Items</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Items</em>' containment reference list.
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_Items()
   * @model type="org.eclipse.emf.tutorial.advanced.po.Item" containment="true"
   * @generated
   */
  EList getItems();

  /**
   * Returns the value of the '<em><b>Comment</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Comment</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Comment</em>' attribute.
   * @see #setComment(String)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_Comment()
   * @model
   * @generated
   */
  String getComment();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getComment <em>Comment</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Comment</em>' attribute.
   * @see #getComment()
   * @generated
   */
  void setComment(String value);

  /**
   * Returns the value of the '<em><b>Order Date</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Order Date</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Order Date</em>' attribute.
   * @see #setOrderDate(Date)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_OrderDate()
   * @model dataType="org.eclipse.emf.tutorial.advanced.datatype.Date"
   * @generated
   */
  Date getOrderDate();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getOrderDate <em>Order Date</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Order Date</em>' attribute.
   * @see #getOrderDate()
   * @generated
   */
  void setOrderDate(Date value);

  /**
   * Returns the value of the '<em><b>Bill To</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Bill To</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Bill To</em>' containment reference.
   * @see #setBillTo(Address)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_BillTo()
   * @model containment="true" required="true"
   * @generated
   */
  Address getBillTo();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getBillTo <em>Bill To</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Bill To</em>' containment reference.
   * @see #getBillTo()
   * @generated
   */
  void setBillTo(Address value);

  /**
   * Returns the value of the '<em><b>Ship To</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ship To</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ship To</em>' containment reference.
   * @see #setShipTo(Address)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_ShipTo()
   * @model containment="true"
   * @generated
   */
  Address getShipTo();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getShipTo <em>Ship To</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ship To</em>' containment reference.
   * @see #getShipTo()
   * @generated
   */
  void setShipTo(Address value);

  /**
   * Returns the value of the '<em><b>Previous Order</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Previous Order</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Previous Order</em>' reference.
   * @see #setPreviousOrder(PurchaseOrder)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_PreviousOrder()
   * @model
   * @generated
   */
  PurchaseOrder getPreviousOrder();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getPreviousOrder <em>Previous Order</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Previous Order</em>' reference.
   * @see #getPreviousOrder()
   * @generated
   */
  void setPreviousOrder(PurchaseOrder value);

  /**
   * Returns the value of the '<em><b>Customer</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.eclipse.emf.tutorial.advanced.customer.Customer#getPurchaseOrders <em>Purchase Orders</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Customer</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Customer</em>' reference.
   * @see #setCustomer(Customer)
   * @see org.eclipse.emf.tutorial.advanced.po.POPackage#getPurchaseOrder_Customer()
   * @see org.eclipse.emf.tutorial.advanced.customer.Customer#getPurchaseOrders
   * @model opposite="purchaseOrders" required="true"
   * @generated
   */
  Customer getCustomer();

  /**
   * Sets the value of the '{@link org.eclipse.emf.tutorial.advanced.po.PurchaseOrder#getCustomer <em>Customer</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Customer</em>' reference.
   * @see #getCustomer()
   * @generated
   */
  void setCustomer(Customer value);

} // PurchaseOrder