/**
 * <copyright>
 * </copyright>
 *
 * $Id: PurchaseOrderImpl.java,v 1.1 2006/03/28 22:06:00 nickb Exp $
 */
package org.eclipse.emf.tutorial.advanced.po.impl;

import java.util.Collection;
import java.util.Date;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.emf.tutorial.advanced.customer.Customer;
import org.eclipse.emf.tutorial.advanced.customer.CustomerPackage;

import org.eclipse.emf.tutorial.advanced.po.Address;
import org.eclipse.emf.tutorial.advanced.po.Item;
import org.eclipse.emf.tutorial.advanced.po.POPackage;
import org.eclipse.emf.tutorial.advanced.po.PurchaseOrder;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Purchase Order</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getItems <em>Items</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getComment <em>Comment</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getOrderDate <em>Order Date</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getBillTo <em>Bill To</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getShipTo <em>Ship To</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getPreviousOrder <em>Previous Order</em>}</li>
 *   <li>{@link org.eclipse.emf.tutorial.advanced.po.impl.PurchaseOrderImpl#getCustomer <em>Customer</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PurchaseOrderImpl extends EObjectImpl implements PurchaseOrder
{
  /**
   * An array of objects representing the values of non-primitive features.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Object[] eVirtualValues = null;

  /**
   * A bit field representing the indices of non-primitive feature values.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected int eVirtualIndexBits0 = 0;

  /**
   * A set of bit flags representing the values of boolean attributes and whether unsettable features have been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected int flags = 0;

  /**
   * The default value of the '{@link #getComment() <em>Comment</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComment()
   * @generated
   * @ordered
   */
  protected static final String COMMENT_EDEFAULT = null;

  /**
   * The default value of the '{@link #getOrderDate() <em>Order Date</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOrderDate()
   * @generated
   * @ordered
   */
  protected static final Date ORDER_DATE_EDEFAULT = null;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PurchaseOrderImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EClass eStaticClass()
  {
    return POPackage.Literals.PURCHASE_ORDER;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList getItems()
  {
    EList items = (EList)eVirtualGet(POPackage.PURCHASE_ORDER__ITEMS);
    if (items == null)
    {
      eVirtualSet(POPackage.PURCHASE_ORDER__ITEMS, items = new EObjectContainmentEList(Item.class, this, POPackage.PURCHASE_ORDER__ITEMS));
    }
    return items;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getComment()
  {
    return (String)eVirtualGet(POPackage.PURCHASE_ORDER__COMMENT, COMMENT_EDEFAULT);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setComment(String newComment)
  {
    String comment = newComment;
    Object oldComment = eVirtualSet(POPackage.PURCHASE_ORDER__COMMENT, comment);
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__COMMENT, oldComment == EVIRTUAL_NO_VALUE ? COMMENT_EDEFAULT : oldComment, comment));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Date getOrderDate()
  {
    return (Date)eVirtualGet(POPackage.PURCHASE_ORDER__ORDER_DATE, ORDER_DATE_EDEFAULT);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOrderDate(Date newOrderDate)
  {
    Date orderDate = newOrderDate;
    Object oldOrderDate = eVirtualSet(POPackage.PURCHASE_ORDER__ORDER_DATE, orderDate);
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__ORDER_DATE, oldOrderDate == EVIRTUAL_NO_VALUE ? ORDER_DATE_EDEFAULT : oldOrderDate, orderDate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Address getBillTo()
  {
    return (Address)eVirtualGet(POPackage.PURCHASE_ORDER__BILL_TO);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetBillTo(Address newBillTo, NotificationChain msgs)
  {
    Object oldBillTo = eVirtualSet(POPackage.PURCHASE_ORDER__BILL_TO, newBillTo);
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__BILL_TO, oldBillTo == EVIRTUAL_NO_VALUE ? null : oldBillTo, newBillTo);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBillTo(Address newBillTo)
  {
    Address billTo = (Address)eVirtualGet(POPackage.PURCHASE_ORDER__BILL_TO);
    if (newBillTo != billTo)
    {
      NotificationChain msgs = null;
      if (billTo != null)
        msgs = ((InternalEObject)billTo).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - POPackage.PURCHASE_ORDER__BILL_TO, null, msgs);
      if (newBillTo != null)
        msgs = ((InternalEObject)newBillTo).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - POPackage.PURCHASE_ORDER__BILL_TO, null, msgs);
      msgs = basicSetBillTo(newBillTo, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__BILL_TO, newBillTo, newBillTo));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Address getShipTo()
  {
    return (Address)eVirtualGet(POPackage.PURCHASE_ORDER__SHIP_TO);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetShipTo(Address newShipTo, NotificationChain msgs)
  {
    Object oldShipTo = eVirtualSet(POPackage.PURCHASE_ORDER__SHIP_TO, newShipTo);
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__SHIP_TO, oldShipTo == EVIRTUAL_NO_VALUE ? null : oldShipTo, newShipTo);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setShipTo(Address newShipTo)
  {
    Address shipTo = (Address)eVirtualGet(POPackage.PURCHASE_ORDER__SHIP_TO);
    if (newShipTo != shipTo)
    {
      NotificationChain msgs = null;
      if (shipTo != null)
        msgs = ((InternalEObject)shipTo).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - POPackage.PURCHASE_ORDER__SHIP_TO, null, msgs);
      if (newShipTo != null)
        msgs = ((InternalEObject)newShipTo).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - POPackage.PURCHASE_ORDER__SHIP_TO, null, msgs);
      msgs = basicSetShipTo(newShipTo, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__SHIP_TO, newShipTo, newShipTo));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PurchaseOrder getPreviousOrder()
  {
    PurchaseOrder previousOrder = (PurchaseOrder)eVirtualGet(POPackage.PURCHASE_ORDER__PREVIOUS_ORDER);
    if (previousOrder != null && previousOrder.eIsProxy())
    {
      InternalEObject oldPreviousOrder = (InternalEObject)previousOrder;
      previousOrder = (PurchaseOrder)eResolveProxy(oldPreviousOrder);
      if (previousOrder != oldPreviousOrder)
      {
        eVirtualSet(POPackage.PURCHASE_ORDER__PREVIOUS_ORDER, previousOrder);
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, POPackage.PURCHASE_ORDER__PREVIOUS_ORDER, oldPreviousOrder, previousOrder));
      }
    }
    return previousOrder;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PurchaseOrder basicGetPreviousOrder()
  {
    return (PurchaseOrder)eVirtualGet(POPackage.PURCHASE_ORDER__PREVIOUS_ORDER);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPreviousOrder(PurchaseOrder newPreviousOrder)
  {
    PurchaseOrder previousOrder = newPreviousOrder;
    Object oldPreviousOrder = eVirtualSet(POPackage.PURCHASE_ORDER__PREVIOUS_ORDER, previousOrder);
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__PREVIOUS_ORDER, oldPreviousOrder == EVIRTUAL_NO_VALUE ? null : oldPreviousOrder, previousOrder));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Customer getCustomer()
  {
    Customer customer = (Customer)eVirtualGet(POPackage.PURCHASE_ORDER__CUSTOMER);
    if (customer != null && customer.eIsProxy())
    {
      InternalEObject oldCustomer = (InternalEObject)customer;
      customer = (Customer)eResolveProxy(oldCustomer);
      if (customer != oldCustomer)
      {
        eVirtualSet(POPackage.PURCHASE_ORDER__CUSTOMER, customer);
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, POPackage.PURCHASE_ORDER__CUSTOMER, oldCustomer, customer));
      }
    }
    return customer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Customer basicGetCustomer()
  {
    return (Customer)eVirtualGet(POPackage.PURCHASE_ORDER__CUSTOMER);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetCustomer(Customer newCustomer, NotificationChain msgs)
  {
    Object oldCustomer = eVirtualSet(POPackage.PURCHASE_ORDER__CUSTOMER, newCustomer);
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__CUSTOMER, oldCustomer == EVIRTUAL_NO_VALUE ? null : oldCustomer, newCustomer);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCustomer(Customer newCustomer)
  {
    Customer customer = (Customer)eVirtualGet(POPackage.PURCHASE_ORDER__CUSTOMER);
    if (newCustomer != customer)
    {
      NotificationChain msgs = null;
      if (customer != null)
        msgs = ((InternalEObject)customer).eInverseRemove(this, CustomerPackage.CUSTOMER__PURCHASE_ORDERS, Customer.class, msgs);
      if (newCustomer != null)
        msgs = ((InternalEObject)newCustomer).eInverseAdd(this, CustomerPackage.CUSTOMER__PURCHASE_ORDERS, Customer.class, msgs);
      msgs = basicSetCustomer(newCustomer, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, POPackage.PURCHASE_ORDER__CUSTOMER, newCustomer, newCustomer));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        Customer customer = (Customer)eVirtualGet(POPackage.PURCHASE_ORDER__CUSTOMER);
        if (customer != null)
          msgs = ((InternalEObject)customer).eInverseRemove(this, CustomerPackage.CUSTOMER__PURCHASE_ORDERS, Customer.class, msgs);
        return basicSetCustomer((Customer)otherEnd, msgs);
    }
    return super.eInverseAdd(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__ITEMS:
        return ((InternalEList)getItems()).basicRemove(otherEnd, msgs);
      case POPackage.PURCHASE_ORDER__BILL_TO:
        return basicSetBillTo(null, msgs);
      case POPackage.PURCHASE_ORDER__SHIP_TO:
        return basicSetShipTo(null, msgs);
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        return basicSetCustomer(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__ITEMS:
        return getItems();
      case POPackage.PURCHASE_ORDER__COMMENT:
        return getComment();
      case POPackage.PURCHASE_ORDER__ORDER_DATE:
        return getOrderDate();
      case POPackage.PURCHASE_ORDER__BILL_TO:
        return getBillTo();
      case POPackage.PURCHASE_ORDER__SHIP_TO:
        return getShipTo();
      case POPackage.PURCHASE_ORDER__PREVIOUS_ORDER:
        if (resolve) return getPreviousOrder();
        return basicGetPreviousOrder();
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        if (resolve) return getCustomer();
        return basicGetCustomer();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__ITEMS:
        getItems().clear();
        getItems().addAll((Collection)newValue);
        return;
      case POPackage.PURCHASE_ORDER__COMMENT:
        setComment((String)newValue);
        return;
      case POPackage.PURCHASE_ORDER__ORDER_DATE:
        setOrderDate((Date)newValue);
        return;
      case POPackage.PURCHASE_ORDER__BILL_TO:
        setBillTo((Address)newValue);
        return;
      case POPackage.PURCHASE_ORDER__SHIP_TO:
        setShipTo((Address)newValue);
        return;
      case POPackage.PURCHASE_ORDER__PREVIOUS_ORDER:
        setPreviousOrder((PurchaseOrder)newValue);
        return;
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        setCustomer((Customer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__ITEMS:
        getItems().clear();
        return;
      case POPackage.PURCHASE_ORDER__COMMENT:
        setComment(COMMENT_EDEFAULT);
        return;
      case POPackage.PURCHASE_ORDER__ORDER_DATE:
        setOrderDate(ORDER_DATE_EDEFAULT);
        return;
      case POPackage.PURCHASE_ORDER__BILL_TO:
        setBillTo((Address)null);
        return;
      case POPackage.PURCHASE_ORDER__SHIP_TO:
        setShipTo((Address)null);
        return;
      case POPackage.PURCHASE_ORDER__PREVIOUS_ORDER:
        setPreviousOrder((PurchaseOrder)null);
        return;
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        setCustomer((Customer)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case POPackage.PURCHASE_ORDER__ITEMS:
        EList items = (EList)eVirtualGet(POPackage.PURCHASE_ORDER__ITEMS);
        return items != null && !items.isEmpty();
      case POPackage.PURCHASE_ORDER__COMMENT:
        String comment = (String)eVirtualGet(POPackage.PURCHASE_ORDER__COMMENT, COMMENT_EDEFAULT);
        return COMMENT_EDEFAULT == null ? comment != null : !COMMENT_EDEFAULT.equals(comment);
      case POPackage.PURCHASE_ORDER__ORDER_DATE:
        Date orderDate = (Date)eVirtualGet(POPackage.PURCHASE_ORDER__ORDER_DATE, ORDER_DATE_EDEFAULT);
        return ORDER_DATE_EDEFAULT == null ? orderDate != null : !ORDER_DATE_EDEFAULT.equals(orderDate);
      case POPackage.PURCHASE_ORDER__BILL_TO:
        return eVirtualGet(POPackage.PURCHASE_ORDER__BILL_TO) != null;
      case POPackage.PURCHASE_ORDER__SHIP_TO:
        return eVirtualGet(POPackage.PURCHASE_ORDER__SHIP_TO) != null;
      case POPackage.PURCHASE_ORDER__PREVIOUS_ORDER:
        return eVirtualGet(POPackage.PURCHASE_ORDER__PREVIOUS_ORDER) != null;
      case POPackage.PURCHASE_ORDER__CUSTOMER:
        return eVirtualGet(POPackage.PURCHASE_ORDER__CUSTOMER) != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected Object[] eVirtualValues()
  {
    return eVirtualValues;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void eSetVirtualValues(Object[] newValues)
  {
    eVirtualValues = newValues;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected int eVirtualIndexBits(int offset)
  {
    switch (offset)
    {
      case 0 :
        return eVirtualIndexBits0;
      default :
        throw new IndexOutOfBoundsException();
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void eSetVirtualIndexBits(int offset, int newIndexBits)
  {
    switch (offset)
    {
      case 0 :
        eVirtualIndexBits0 = newIndexBits;
        break;
      default :
        throw new IndexOutOfBoundsException();
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (comment: ");
    result.append(eVirtualGet(POPackage.PURCHASE_ORDER__COMMENT, COMMENT_EDEFAULT));
    result.append(", orderDate: ");
    result.append(eVirtualGet(POPackage.PURCHASE_ORDER__ORDER_DATE, ORDER_DATE_EDEFAULT));
    result.append(')');
    return result.toString();
  }

} //PurchaseOrderImpl